#define  USE_HY17M28_2M
#include <SFRType.h>
#include "main.h"
#include "Display.h"
#include "LED_TABLE.h"

extern unsigned char work_flag;

extern unsigned char LED[8];
extern long signed  ADCData1;
extern unsigned char LEDScan;
/*----------------------------------------------------------------------------*/
/* LED_Display_show Function                                                      */
/*----------------------------------------------------------------------------*/
void LED_Display_show(signed long DATA)
{
  //display range +8388607~-8388608 (dec)
  //display range 0x7FFFFF~ 0x800000 (hex)
  ADCData1=DATA;
  if((ADCData1<0)||(ADCData1>0x80000000))  // plus-minus sign judgment
  {
	  ADCData1=~ADCData1;
	  ADCData1++;
	  if(work_flag&ADC_T)//adc code mode
	  {
       //LED[7]=(LED[7]| 0x40)-0x10 ;  //UartTxBuffer[0]='-'; //no '.'
       LED[7]=(LED[7]&0xef)| 0x40;
      }
      else
      {
       LED[7]=LED[7]|0x50;// | 0x40|0x10;  //UartTxBuffer[0]='-'; + '.'
      }
  }
  else
  {
    if(work_flag&ADC_T)//adc code mode
    {
      if(LED[7]==0x40)
      {
       //LED[7]=LED[7] - 0x40-0x10; //UartTxBuffer[0]='+'; and no '.'
       LED[7]=LED[7]&0xaf;
      }
      else
       //LED[7]=LED[7] - 0x10; ////no '.'
       LED[7]=LED[7]&0xef;

    }
    else//temperature mode
    {
      if(LED[7]==0x40)
      {
       //LED[7]=(LED[7] - 0x40)|0x10; //UartTxBuffer[0]='+'; and '.'
       LED[7]=(LED[7]&0xbf)|0x10;
      }
      else
       LED[7]=LED[7]|0x10; //no '.'
    }
  }
  DATA=ADCData1;

  ADCData1= seg[DATA%10];
  LED[6]= GetDisplay(ADCData1,7);
  DATA /=10;

  ADCData1= seg[DATA%10];
 // if(ADCData1!=0x3f)
    LED[5]= GetDisplay(ADCData1,6);
  DATA /=10;

  ADCData1= seg[DATA%10];
 // if(ADCData1!=0x3f)
    LED[4]= GetDisplay(ADCData1,5);
  DATA /=10;

  ADCData1= seg[DATA%10];
 // if(ADCData1!=0x3f)
    LED[3]= GetDisplay(ADCData1,4);
  DATA /=10;

  ADCData1= seg[DATA%10];
  if(ADCData1!=0x3f)
  LED[2]= GetDisplay(ADCData1,3);
  else
   LED[2]=0;
  DATA /=10;

  if(work_flag&cal_ok)
    ADCData1=Char_C;
  else
    ADCData1= seg[DATA%10];
  if(ADCData1!=0x3f)
    LED[1]= GetDisplay(ADCData1,2);
  else
   LED[1]=0;
  DATA /=10;

  ADCData1= seg[DATA%10];
  if(ADCData1!=0x3f)
   LED[0]= GetDisplay(ADCData1,1);
  else
   LED[0]=0;

}

/*----------------------------------------------------------------------------*/
/* LED_Display_h Function                                                         */
/*----------------------------------------------------------------------------*/
void LED_Display_h(unsigned char ledx, unsigned char On_OFF)
{

  unsigned char LEDScan_h, On_OFF_h ;
  LEDScan_h=ledx;
  On_OFF_h=On_OFF;

  switch(LEDScan_h)
  {
    case 0x1:
    {
      if(On_OFF_h==1)
      {LED[7]=LED[7] | 0x01;}
      if(On_OFF_h==0)
      {LED[7]=LED[7] -0x01;}
      break;
    }
    case 0x2:
    {
      if(On_OFF_h==1)
      {LED[7]=LED[7] | 0x02;}
      if(On_OFF_h==0)
      {LED[7]=LED[7] - 0x02;}
      break;
    }
    case 0x3:
    {
      if(On_OFF_h==1)
      {LED[7]=LED[7] | 0x04;}
      if(On_OFF_h==0)
      {LED[7]=LED[7] - 0x04;}
      break;
    }
    case 0x4:
    {
      if(On_OFF_h==1)
      {LED[7]=LED[7] | 0x08;}
      if(On_OFF_h==0)
      {LED[7]=LED[7] - 0x08;}
      break;
    }
    case 0x5:
    {
      if(On_OFF_h==1)
      {LED[7]=LED[7] | 0x10;}
      if(On_OFF_h==0)
      {LED[7]=LED[7] - 0x10;}
      break;
    }
    case 0x6:
    {
      if(On_OFF_h==1)
      {LED[7]=LED[7] | 0x20;}
      if(On_OFF_h==0)
      {LED[7]=LED[7] - 0x20;}
      break;
    }
    case 0x7:
    {
      if(On_OFF_h==1)
      {LED[7]=LED[7] | 0x40;}
      if(On_OFF_h==0)
      {LED[7]=LED[7] - 0x40;}
      break;
    }
  }

}

/*------------------------------------------------------------------------------|
|  Function: GetDisplay                                                         |
|                                                                               |
|  Parameters:                                                                  |
|         show         - [in]	LED show data                                     |
|         ledx         - [in] LED show ledx                                     |
|  Returns:                                                                     |
|         None                                                                  |
|                                                                               |
|  Description:                                                                 |
|         This function is used to open LED Driver                              |
|------------------------------------------------------------------------------*/
unsigned char GetDisplay(unsigned char show,unsigned char ledx)
{
  unsigned char RRTemp,RLTemp,RRR;
  RRTemp=show;
  RLTemp=show;

  RRR=0xff;

  RRTemp=(RRTemp<<1);
  RRR=(RRR<<ledx);
  RRTemp &= RRR;

  RRR=0xff;
  RRR=RRR>>(8-ledx);
  RLTemp &= RRR;
  RRR= RLTemp | RRTemp;

  return RRR;
}
void show_cal(void)
{
LED[7]=0;
ADCData1=Char_P;
LED[6]=GetDisplay(ADCData1,7);
ADCData1=Char_L;
LED[5]=GetDisplay(ADCData1,6);
ADCData1=Char_A;
LED[4]=GetDisplay(ADCData1,5);
ADCData1=Char_C;
LED[3]=GetDisplay(ADCData1,4);

LED[2]=0;
LED[1]=0;
LED[0]=0;
}
void SHOWCAL1(void)
{
LED[7]=0;
ADCData1=seg[1];
LED[6]=GetDisplay(ADCData1,7);
ADCData1=Char_L;
LED[5]=GetDisplay(ADCData1,6);
ADCData1=Char_A;
LED[4]=GetDisplay(ADCData1,5);
ADCData1=Char_C;
LED[3]=GetDisplay(ADCData1,4);

LED[2]=0;
LED[1]=0;
LED[0]=0;
}

void SHOWCAL2(void)
{
LED[7]=0;
ADCData1=seg[2];
LED[6]=GetDisplay(ADCData1,7);
ADCData1=Char_L;
LED[5]=GetDisplay(ADCData1,6);
ADCData1=Char_A;
LED[4]=GetDisplay(ADCData1,5);
ADCData1=Char_C;
LED[3]=GetDisplay(ADCData1,4);
LED[2]=0;
LED[1]=0;
LED[0]=0;
}
//====================
void HYCON_show(void)
{
LED[7]=0;
ADCData1=Char_n;//Char_N;
LED[6]=GetDisplay(ADCData1,7);
ADCData1=Char_O;
LED[5]=GetDisplay(ADCData1,6);
ADCData1=Char_C;
LED[4]=GetDisplay(ADCData1,5);
ADCData1=Char_Y;
LED[3]=GetDisplay(ADCData1,4);
ADCData1=Char_H;
LED[2]=GetDisplay(ADCData1,3);
LED[1]=0;
LED[0]=0;
}
//===============================
//show'----',when is'no-calibrate/high over'
//=======================================
void error_show(void)
{
LED[7]=0;
ADCData1=seg_g;//Char_N;
LED[6]=GetDisplay(ADCData1,7);
ADCData1=seg_g;
LED[5]=GetDisplay(ADCData1,6);
ADCData1=seg_g;
LED[4]=GetDisplay(ADCData1,5);
ADCData1=seg_g;
LED[3]=GetDisplay(ADCData1,4);
if(work_flag&ADC_NO_CAL)//no calibrate
 ADCData1=Char_C;
else if(work_flag&temper_high)
 ADCData1=Char_H;
LED[2]=GetDisplay(ADCData1,3);
LED[1]=0;
LED[0]=0;
}
//====================================
//LED ALL OFF
//=======================================
void LED_OFF(void)
{
LED[7]=0;
LED[6]=0;
LED[5]=0;
LED[4]=0;
LED[3]=0;
LED[2]=0;
LED[1]=0;
LED[0]=0;
}
