void Delay(unsigned int num);
void COMPENSATE(void);
void SYS_Parameter_Read(void);
void CLEAR_EEPROM(unsigned char num);//
void EERDCLR(unsigned char num);
void KEY_DEAL(void);
//================================================

//===========================================
#define HAO_2MHZ
//#define HAO_4MHZ
//#define HAO_8MHZ
//#define HAO_16MHZ

//#define ide 
#define IC_BODY

#ifdef ide
 #define PT_CAL PT1
 #define CAL_PIN  0x40//bit6 
#endif

#ifdef IC_BODY
 #define PT_CAL PT3
 #define CAL_PIN  0x4//bit2
#endif


#define NOP()        __asm__ ("NOP")  //NOP Mode

#define ADIE  0x20 //adc interrupt enable 
#define ADIF  0x20 //adc interrupt flag;

#define KEY_POWER 0x80 //PT3.7
//#define KEY_SCAN  0x10  //PT1.4
//unsigned char work_flag=0;
 #define adc_int_flag 0x01 //adc interrupt flag
 #define adc_ok_flag  0x02 //just finish adc net measure flag
 #define adc_chopper  0x04 //adc SW chopper flag
 #define ADC_finish	  0x08 //finish temperature caculate
 #define cal_ok       0x10 //calibrate ok flag
 #define ADC_T	      0x20 //ADC CODE and Temperature exchange show
 #define ADC_NO_CAL   0x40 //adc not calibrate flag
 #define work_mode    0x80 //0:normal mode ;1:other mode(include reset/idle)
 #define temper_high  0x80 //temperature is high over
 
//unsigned char KEYWORK_FLAG=0; //key flag
 #define key_scan_flag     0x01 
 #define key_power_flag    0x02
//=change the follow define,when the R-T/V2T/T2V table be changed== 
#define R2T_HEADER 0x5700  //R2T TABLE COUNTER HEADER
#define V2T_VALUE37 0xa8a //the voltage value when at 37c temperature
#define V2T_Length 0xa4 //v2t table size is 'V2T_Length+1'
#define T2V_Length 0x4A //T2V table size is' T2V_Length+1'
//--------------------------------------------------------------
#define high_temper 3750  //high temperature
#define low_temper 3200  //low temperature

#define TP_length  8  //TP ADC drop data Bits
#define RX_length  6  //RF/TS ADC drop data Bits

#define calibrate_count  0x7 //